Combination = {}

local function n_choose_k(n, k)
	local value = 1

	for i = 1, k do
		value = value * (n - i + 1)
	end

	for i = 1, k do
		value = math.floor(value / (k - i + 1))
	end

	return value
end

function Combination.to_index(combination, k)
	local n = table.getn(combination)

	local index = 0

	local i = n - 1
	while i >= 0 and k > 0 do
		if combination[i + 1] then
			index = index + n_choose_k(i, k)
			k = k - 1
		end

		i = i - 1
	end

	return index
end

function Combination.from_index(index, k, n)
	local combination = {}
	for i = 1, n do
		combination[i] = false
	end

	local i = n - 1
	while i >= 0 and k >= 0 do
		if index >= n_choose_k(i, k) then
			combination[i + 1] = true
			index = index - n_choose_k(i, k)
			k = k - 1
		end

		i = i - 1
	end

    return combination
end

function Combination.number(k, n)
	return n_choose_k(n, k)
end

return Combination
