require "phase1"
require "phase2"

Kociemba = {}

function Kociemba.solutions(state)
	return coroutine.wrap(function()
		local length = 1e6

		for solution1 in Phase1:solutions(state) do
			local state2 = state
			for _, move_name in ipairs(solution1) do
				state2 = state2:mul(State.moves[move_name])
			end

			local max_length = math.min(length - table.maxn(solution1), 12)
			for solution2 in Phase2:solutions(state2, max_length) do
				length = table.maxn(solution1) + table.maxn(solution2)

				local solution = {}
				for _, move_name in ipairs(solution1) do
					table.insert(solution, move_name)
				end
				for _, move_name in ipairs(solution2) do
					table.insert(solution, move_name)
				end

				coroutine.yield(solution)

				break
			end
		end
	end)
end
