Permutation = {}

function Permutation.to_index(permutation)
	local n = table.getn(permutation)

	local index = 0
	for i = 1, n - 1 do
		index = index * (n + 1 - i)
		for j = i + 1, n do
			if permutation[i] > permutation[j] then
				index = index + 1
			end
		end
	end

	return index;
end

function Permutation.from_index(index, n)
	local permutation = {}

	permutation[n] = 1
	for i = n - 1, 1, -1 do
		permutation[i] = 1 + index % (n + 1 - i)
		index = math.floor(index / (n + 1 - i))
		for j = i + 1, n do
			if permutation[j] >= permutation[i] then
				permutation[j] = permutation[j] + 1
			end
		end
	end

	return permutation
end

function Permutation.number(n)
	local number = 1
	for i = 1, n do
		number = number * i
	end

	return number
end

return Permutation
