package com.puzzletimer.solvers;

public class Permutation {
    public static int toIndex(int[] permutation) {
        int index = 0;
        for (int i = 0; i < permutation.length - 1; i++) {
            index *= permutation.length - i;
            for (int j = i + 1; j < permutation.length; j++) {
                if (permutation[i] > permutation[j]) {
                    index++;
                }
            }
        }

        return index;
    }

    public static int[] fromIndex(int index, int length) {
        int[] permutation = new int[length];
        permutation[length - 1] = 0;
        for (int i = length - 2; i >= 0; i--) {
            permutation[i] = (index % (length - i));
            index /= length - i;
            for (int j = i + 1; j < length; j++) {
                if (permutation[j] >= permutation[i]) {
                    permutation[j]++;
                }
            }
        }

        return permutation;
    }

    public static long toIndexLong(int[] permutation) {
        long index = 0;
        for (int i = 0; i < permutation.length - 1; i++) {
            index *= permutation.length - i;
            for (int j = i + 1; j < permutation.length; j++) {
                if (permutation[i] > permutation[j]) {
                    index++;
                }
            }
        }

        return index;
    }
}
