package com.puzzletimer.solvers;

public class ZeroSumOrientation {
    public static int toIndex(int[] orientation, int nValues) {
        int index = 0;
        for (int i = 0; i < orientation.length - 1; i++) {
            index = nValues * index + orientation[i];
        }

        return index;
    }

    public static int[] fromIndex(int index, int nValues, int length) {
        int[] orientation = new int[length];
        orientation[length - 1] = 0;
        for (int i = length - 2; i >= 0; i--) {
            orientation[i] = (index % nValues);
            index /= nValues;

            orientation[length - 1] += orientation[i];
        }
        orientation[length - 1] = (nValues - orientation[length - 1] % nValues) % nValues;

        return orientation;
    }
}
